# Invoke all FitLibrary unit tests.
# copyright 2004 John H. Roth Jr. Licensed under the GNU General Public License, v2.
# See license.txt for details, and for the disclaimer of liability and warrenty.

import sys

import unittest
from fitLib.tests import CalculateFixtureTest
from fitLib.tests import FlowFixtureFixtureTest
from fitLib.tests import TestListTree
from fitLib.tests import TestParseUtility

try:
    False
except:
    True = 1
    False = 0

def makeAllTests():
    suite = CalculateFixtureTest.makeCalculateFixtureSpecifications()
    suite.addTests((FlowFixtureFixtureTest.makeFlowFixtureFixtureTest(),))
    suite.addTests((TestListTree.makeListTreeTest(),))
    suite.addTests((TestParseUtility.makeParseUtilityTest(),))
    return suite

if __name__ == '__main__':
    unittest.main(defaultTest='makeAllTests')
