# Invoke all batch unit tests, not including FitLibrary
#LegalStuff
# copyright 2004 John H. Roth Jr. Licensed under the GNU General Public License, v2.
# See license.txt for details, and for the disclaimer of liability and warrenty.
#endLegalStuff

import os
import sys
##pathList = "\n".join(sys.path)
##print "Path List:\n%s" % pathList

import unittest
import ActionFixtureTest
import CellHandlerTest
import CheckTest
import ColumnFixtureTest
import ColumnFixtureTestFixtureTest
import FitExceptionTest
import FitServerTest
import FixtureTest
import FixtureLoaderTest
import FrameworkTest
import MiscTest
import OptionsTest
import ParseTest
import RowFixtureTest
import RunnerImplementationTest
import taProtocolTest
import TypeAdapterTest
import VariationsTest

try:
    False
except: #pragma: no cover
    True = 1
    False = 0

def makeAllTests():
    theSuite = CellHandlerTest.makeCellHandlerTest()
    theSuite.addTests((
        ActionFixtureTest.makeActionFixtureTest(),
        CheckTest.makeCheckTest(),
        ColumnFixtureTest.makeColumnFixtureTest(),
        ColumnFixtureTestFixtureTest.makeColumnFixtureTestFixtureTest(),
        FitExceptionTest.makeFitExceptionTest(),
        FitServerTest.makeFitServerTest(),
        FixtureTest.makeFixtureTest(),
        FixtureLoaderTest.makeFixtureLoaderTest(),
        FrameworkTest.test_suite(),
        MiscTest.makeMiscTest(),
        OptionsTest.makeOptionsTest(),
        ParseTest.makeParseTest(),
        RowFixtureTest.makeRowFixtureTest(),
        RunnerImplementationTest.makeRunnerImplementationTest(),
        TypeAdapterTest.makeTypeAdapterTest(),
        taProtocolTest.makeProtocolTest(),
        VariationsTest.makeVariationsTest(),
        ))
    return theSuite

if __name__ == '__main__':
    print "current directory: '%s'" % os.getcwd()
    unittest.main(defaultTest='makeAllTests')